MODULE Lines;

FROM StreamFile IMPORT ChanId, Open, read, Close, OpenResults;
FROM TextIO IMPORT ReadString, WriteLn, WriteString, WriteChar, SkipLine;
FROM IOResult IMPORT ReadResult, ReadResults;
FROM StdChans IMPORT StdInChan, StdOutChan;
FROM WholeIO IMPORT WriteInt;

TYPE line = ARRAY[0..100] OF CHAR;
     AllLines = ARRAY [1..1000] OF line; 
     
VAR
  infile, stdOut, stdIn : ChanId;
  res : OpenResults;
  inputline: line;
  i, j     : INTEGER;
  numlines : INTEGER;
  document: AllLines;

BEGIN
  (* Read and Store from input into document *)
  stdOut := StdOutChan(); (* to force screen output *)
  stdIn := StdInChan(); (* to force keyboard input *)
  
  Open (infile, "input.txt", read, res);
  IF res = opened
    THEN
      i := 1;
      REPEAT  (* Collect the info from the file *)
        ReadString (infile, inputline); 
        IF ReadResult (infile) = allRight
          THEN
            SkipLine (infile);
            document[i]:=inputline;
            WriteString (stdOut, inputline);
            WriteString (stdOut, document[i]);
            WriteLn (stdOut);
            i:=i+1;
          END;  (* if *)
      UNTIL ReadResult (infile) # allRight;
     Close (infile);
     WriteLn (stdOut);
    ELSE
     WriteString (stdOut,"Sorry, couldn't open the file");
     WriteLn (stdOut);
    END; (* if *)
    
  (* output document line by line, char by char *)
  numlines :=i-1;
  WriteInt(stdOut, numlines, 3);
  WriteLn (stdOut);
 
  FOR i:= 1 TO numlines DO
    j:=0;
    REPEAT 
    IF ORD(document[i][j]) <> 0 
      THEN  
        WriteChar (stdOut, document[i][j]); 
        j :=j+1;
    END;
    UNTIL ORD(document[i][j]) = 0 ;
    WriteLn (stdOut);
  END;
END Lines.