MODULE ReadWritestdout;

(* Written by R.J. Sutcliffe *)
(* to illustrate the use of StreamFile *)
(* using ISO standard Modula-2 *)
(* last revision 1994 02 23 *)

FROM StreamFile IMPORT ChanId, Open, read, Close, OpenResults;
FROM TextIO IMPORT ReadString, WriteLn, WriteString, SkipLine;
FROM IOResult IMPORT ReadResult, ReadResults;
FROM StdChans IMPORT StdInChan, StdOutChan;

VAR
  infile, stdOut, stdIn : ChanId;
  res : OpenResults;
  str: ARRAY [1..100] OF CHAR;

BEGIN
  stdOut := StdOutChan(); (* to force screen output *)
  stdIn := StdInChan(); (* to force keyboard input *)
  Open (infile, "input.txt", read, res);

  IF res = opened
    THEN
      REPEAT  (* Collect the info from the file *)
        ReadString (infile, str); 
        IF ReadResult (infile) = allRight
          THEN
            SkipLine (infile);
            WriteString (stdOut, str);
            WriteLn (stdOut);
          END;  (* if *)
      UNTIL ReadResult (infile) # allRight;
     Close (infile);
     WriteLn (stdOut);
    ELSE
     WriteString (stdOut,"Sorry, couldn't open the file");
     WriteLn (stdOut);
    END; (* if *)
END ReadWritestdout.
